From 1c0fb5d978a45a1be0aec977ead59f9f5ff8b326 Mon Sep 17 00:00:00 2001
From: Dhriti Shikhar <dhrish20@gmail.com>
Date: Jan 21 2016 21:31:48 +0000
Subject: [PATCH 267/1001] Adds a github issues widget


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 88ba8a7..03084ac 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -13,6 +13,7 @@ from hubs.widgets import meetings
 from hubs.widgets import pagure_pr
 from hubs.widgets import github_pr
 from hubs.widgets import pagureissues
+from hubs.widgets import githubissues
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -35,6 +36,7 @@ registry = {
     'pagure_pr': pagure_pr,
     'github_pr': github_pr,
     'pagureissues': pagureissues,
+    'githubissues': githubissues,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/githubissues.py b/hubs/widgets/githubissues.py
new file mode 100644
index 0000000..3eef711
--- /dev/null
+++ b/hubs/widgets/githubissues.py
@@ -0,0 +1,85 @@
+from hubs.widgets.chrome import panel
+from hubs.hinting import hint
+from hubs.widgets.base import argument
+import hubs.validators as validators
+import jinja2
+import requests
+
+chrome = panel("Github: Newest Open Tickets")
+
+template = jinja2.Template("""
+  <br />
+  {% for i in range(display_number) %}
+    <div>
+      <table class="table-responsive table-condensed">
+        <tr>
+          <td valign="top" class="panel-heading">
+            <b>#{{ all_issues[i]['num'] }}</b>
+          </td>
+          <td width="300px">
+            <b>{{ all_issues[i]['title'] }}</b>
+          </td>
+        </tr>
+      </table>
+      <table class="table-responsive table-condensed">
+        <tr>
+          <td width="300px">
+            <font size="2">
+              <i>Opened by <a href="https://github.com/{{ all_issues[i]['openedby'] }}" target="_blank">{{ all_issues[i]['openedby'] }}</a></i>
+              {% if all_issues[i]['assignee']|string() == "None" %}
+                <br /><i>Unclaimed</i>
+              {% else %}
+                 <br /><i>Assigned by <a href="https://github.com/{{ all_issues[i]['assignee'] }}" target="_blank">{{ all_issues[i]['assignee'] }}</a></i>
+              {% endif %}
+            </font>
+          </td>
+          <td>
+             <a href="https://github.com/{{ org }}/{{ repo }}/issues/{{ all_issues[i]['num'] }}" target="_blank">
+               <button type="button" class="btn btn-default" aria-label="Left Align">
+                 <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
+               </button>
+             </a>
+          </td>
+        </tr>
+      </table>
+    </div>
+    {% endfor %}
+    <div class="row">
+      <a href="https://github.com/{{ org }}/{{ repo }}/issues" target="_blank"><center>All Issues</center></a>
+    </div>
+""")
+
+@argument(name="repo",
+	default=None,
+	validator=validators.repo,
+	help="Repo")
+def data(session, widget, display_number, org, repo):
+  url = '/'.join(['https://api.github.com/repos',org,repo,"issues"])
+  issue_response = requests.get(url)
+  data = issue_response.json()
+  all_issues = list()
+  for i in range(0,10):
+    issue_details=dict()
+    issue_num=data[i]['number']
+    issue_title=data[i]['title']
+    issue_openedby=data[i]['user']['login']
+    if(data[i]['assignee']!=None):
+      issue_assignee=data[i]['assignee']['login']
+    else:
+      issue_assignee=data[i]['assignee']
+    issue_details['num']=issue_num
+    issue_details['title']=issue_title
+    issue_details['openedby']=issue_openedby
+    issue_details['assignee']=issue_assignee
+    all_issues.append(issue_details)
+  all_issues.reverse()
+  return dict(
+    org=org,
+    repo=repo,
+    all_issues=all_issues,
+    display_number=display_number,
+  )
+
+@hint()
+def should_invalidate(message, session, widget):
+  raise NotImplementedError

